#ifndef CHROOT_MESSAGES_H
#define CHROOT_MESSAGES_H

#pragma once

#include <sstream>

void DisplayError(const std::string& str);
void DisplayStatus(const std::string& str);
std::string GetModuleMessage(HMODULE hMod, DWORD messageId);
void DisplayLastError(const char* pString);
void PrintHelp();

template<class ErrType>
std::string GetErrorMessage(ErrType err)
{
	HMODULE hMod = NULL;
	// this is probably an NTSTATUS
	if(err & 0x80000000)
	{
		hMod = GetModuleHandle(L"ntdll.dll");
	}
	// make sure we're not breaking anything
	C_ASSERT(sizeof(NTSTATUS) == sizeof(DWORD));
	return GetModuleMessage(hMod, static_cast<DWORD>(err));
}

template<class Type>
void DisplayError(const char* pString, Type err)
{
	std::ostringstream stream;
	stream << pString << " - Error: " << GetErrorMessage(err);
	DisplayError(stream.str());
}

#endif
