#include "stdafx.h"

std::wstring ExpandEnvString(LPCWSTR pStr)
{
	DWORD req = ExpandEnvironmentStrings(pStr, NULL, 0) + 1;
	std::wstring expanded(req, 0);
	req = ExpandEnvironmentStrings(pStr, &expanded[0], req);
	// don't need the inbuilt nul
	expanded.resize(req - 1);
	return expanded;
}

WCHAR FindARootedDriveLetter(DWORD drivesToKeep)
{
	DWORD driveBitmap = GetLogicalDrives();
	DWORD index = 0;
	while(BitScanForward(&index, driveBitmap))
	{
		ASSERT(index < 26);
		if(!BitTest(reinterpret_cast<LONG*>(&drivesToKeep), index))
		{
			return static_cast<WCHAR>(L'A' + index);
		}
		driveBitmap ^= (1 << index);
	}
	// user wanted to keep all drives, what was the point of chrooting?
	// use the first available drive
	BitScanForward(&index, driveBitmap);
	return static_cast<WCHAR>(L'A' + index);
}
