#include "stdafx.h"
#include "undeclared.h"

pfnNtCreateSymbolicLinkObject NtCreateSymbolicLinkObject = NULL;
pfnRtlDetermineDosPathNameType_U RtlDetermineDosPathNameType_U = NULL;
pfnNtSetInformationProcess NtSetInformationProcess = NULL;
pfnNtCreateDirectoryObject NtCreateDirectoryObject = NULL;
pfnRtlSetLastWin32ErrorAndNtStatusFromNtStatus RtlSetLastWin32ErrorAndNtStatusFromNtStatus = NULL;

template<class FnPtr>
BOOL GetNtdllFnPtr(HMODULE hMod, FnPtr& ptr, LPCSTR pName)
{
	ptr = reinterpret_cast<FnPtr>(GetProcAddress(hMod, pName));
	return !!ptr;
}

#define GET_FN_PTR(hMod, Name) GetNtdllFnPtr(hMod, Name, #Name)

BOOL InitNtDllFnPtrs()
{
	HMODULE hNtdll = GetModuleHandle(L"ntdll.dll");
	return
		GET_FN_PTR(hNtdll, NtCreateSymbolicLinkObject) &&
		GET_FN_PTR(hNtdll, RtlDetermineDosPathNameType_U) &&
		GET_FN_PTR(hNtdll, NtSetInformationProcess) &&
		GET_FN_PTR(hNtdll, NtCreateDirectoryObject) &&
		GET_FN_PTR(hNtdll, RtlSetLastWin32ErrorAndNtStatusFromNtStatus);
}
